# MusicTrackSelectionWindow Struct Reference

Inheritance diagram for MusicTrackSelectionWindow:

## Public Member Functions
| MusicTrackSelectionWindow (const WindowDesc *desc, WindowNumber number)
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnInvalidateData (int data=0)
| Some data on this window has become invalid.
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | OnPaint ()
| The window must be repainted.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.

## Detailed Description

Definition at line 296 of file music_gui.cpp.

## Member Function Documentation

virtual void MusicTrackSelectionWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget |
| ) |  |  | const`[inline, virtual]`

Draw the contents of a nested widget.

Parameters:

  | r | Rectangle occupied by the widget.
  | widget | Number of the widget to draw.

Note:
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 360 of file music_gui.cpp.

References DrawString(), FONT_HEIGHT_SMALL, GetSongName(), GetTrackNumber(), GfxFillRect(), NUM_SONGS_AVAILABLE, SetDParam(), SetDParamStr(), StrEmpty(), WD_FRAMERECT_LEFT, WD_FRAMERECT_RIGHT, and WD_FRAMERECT_TOP.

virtual void MusicTrackSelectionWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count |
| ) |  |  | `[inline, virtual]`

A click with the left mouse button has been made on the window.

Parameters:

  | pt | the point inside the window that has been clicked.
  | widget | the clicked widget.
  | click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 400 of file music_gui.cpp.

References FONT_HEIGHT_SMALL, GetTrackNumber(), BaseMedia< MusicSet >::GetUsedSet(), IsInsideMM(), NUM_SONGS_AVAILABLE, NUM_SONGS_PLAYLIST, and Window::SetDirty().

virtual void MusicTrackSelectionWindow::OnInvalidateData | ( | int | data = `0` | ) | `[inline, virtual]`

Some data on this window has become invalid.

Parameters:

  | data | information about the changed data.

Reimplemented from Window.

Definition at line 315 of file music_gui.cpp.

References Window::SetDirty(), Window::SetWidgetDisabledState(), and Window::SetWidgetLoweredState().

virtual void MusicTrackSelectionWindow::OnPaint | ( |  | ) | `[inline, virtual]`

The window must be repainted.

Note:
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 395 of file music_gui.cpp.

References Window::DrawWidgets().

virtual void MusicTrackSelectionWindow::SetStringParameters | ( | int | widget | ) | const`[inline, virtual]`

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters:

  | widget | Widget number.

Reimplemented from Window.

Definition at line 306 of file music_gui.cpp.

References SetDParam().

virtual void MusicTrackSelectionWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize |
| ) |  |  | `[inline, virtual]`

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters:

  | widget | Widget number.
  | size | Size of the widget.
  | padding | Recommended amount of space between the widget content and the widget edge.
  | fill | Fill step of the widget.
  | resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 324 of file music_gui.cpp.

References GetSongName(), GetStringBoundingBox(), GetTrackNumber(), max(), maxdim(), NUM_SONGS_AVAILABLE, SetDParam(), SetDParamStr(), and StrEmpty().

The documentation for this struct was generated from the following file:

- src/music_gui.cpp